为什么我会使用“service sshd reload”而不是“service sshd restart”?

从我在Linux上的testing看来,似乎是这样

service sshd reload

  • 只有当sshd已经在运行时才能工作
  • 如果sshd_config文件有问题,停止sshd
  • 即使sshd_config文件有问题,也会返回错误代码0

service sshd restart

  • 无论sshd是否已经在运行,都可以工作
  • 如果sshd_config文件具有无效的语法或其他问题,则停止sshd
  • 如果sshd_config文件有问题,则返回非零错误代码

我明白,他们正在执行不同的操作,但在我看来,不应该总是使用service sshd restart 。 在某些情况下, service sshd reload有什么理由可取吗?

Solutions Collecting From Web of "为什么我会使用“service sshd reload”而不是“service sshd restart”?"

当你运行服务sshd命令可以重新加载/重新启动它实际上运行一个修改环境的程序就像这样:

  env -i PATH="$PATH" TERM="$TERM" "${SERVICEDIR}/${SERVICE}" ${OPTIONS} 

例如:

  env -i PATH=/sbin:/usr/sbin:/bin:/usr/bin TERM=xterm /etc/init.d/sshd reload 

在这两种情况下(重启/重载),sshd命令的功能几乎相同:

重新加载 :试图杀死发送HUP信号的进程,正如你在snipet上看到的,它需要进程的PID来完成它。 (不管sshd是否已经运行)

  reload() { echo -n $"Reloading $prog: " if [ -n "`pidfileofproc $SSHD`" ] ; then killproc $SSHD -HUP else failure $"Reloading $prog" fi RETVAL=$? echo } 

重新启动 :它只会像执行stop-> start一样执行。

  restart() { stop start } start() { [ -x $SSHD ] || exit 5 [ -f /etc/ssh/sshd_config ] || exit 6 # Create keys if necessary if [ "x${AUTOCREATE_SERVER_KEYS}" != xNO ]; then do_rsa1_keygen do_rsa_keygen do_dsa_keygen fi echo -n $"Starting $prog: " $SSHD $OPTIONS && success || failure RETVAL=$? [ $RETVAL -eq 0 ] && touch $lockfile echo return $RETVAL } stop() { echo -n $"Stopping $prog: " if [ -n "`pidfileofproc $SSHD`" ] ; then killproc $SSHD else failure $"Stopping $prog" fi RETVAL=$? # if we are in halt or reboot runlevel kill all running sessions # so the TCP connections are closed cleanly if [ "x$runlevel" = x0 -o "x$runlevel" = x6 ] ; then trap '' TERM killall $prog 2>/dev/null trap TERM fi [ $RETVAL -eq 0 ] && rm -f $lockfile echo } 

某些应用程序(包括多个Web服务器)支持重新加载其配置,而不必重新启动。 在这种情况下, reload将是发出信号的最好方式。

作为一个用例,如果sshd实际上支持重新加载配置而不影响现有连接,那将是非常好的。 这将允许一个验证新的配置,而不会丢失当前的SSH连接(例如,当修改权限,以确保您仍然可以登录)。

更多阅读: 所有systemd单元操作的列表

只要提一下:如上面的例子中人们使用sshd,那是守护进程,服务是ssh。 正确的行应该是:

 service ssh reload 

我认为这个“重新加载”可以在一个shell脚本中用于多服务恢复到初始状态,在这种情况下我们不知道服务是否在运行,所以我们只是让所有这些服务“重新加载”。

如果我们在这种情况下使用“重新启动”,那么我们没有使用的一些服务将启动。

通常为了调试单个服务的问题(或修改),我们希望这个服务像“sshd”启动,“restart”应该更好,因为我们不需要检查这个服务是否运行成功。